/*
  Arduino Uno Pin Assignment
  D2 = encoder Middle
  D3 = Zero Cross Detect Circuit
  D4 = Topheater Fan
  D5 = encoder aPin
  D6 = encoder bPin
  D7 = Buzzer Pin
  D8 = CS1 Max6675
  D9 = Output preheater
  D10 = Output topheater
  D11 = CS2 Max6675
  D12 = SO Max6675
  D13 = SCK Max6675
  A0 = Toggle Switch
  A1 = protection Relay pin
  A4 = SCL
  A5 = SDA

  note:

  i already had mine BGA Rework Station that uses DUE and the NEXTION Display;
  but i wanted to build a cheaper one, so i decided to build and code this one:

  if your an IT or an Engineer with the background in electronics,
  just use your imagination and analyze the flaw of the program to
  make you fully understand how it works.
  LOL

  this is the 436th attempt to finally make it work flawlessly without a glitch
  this one uses library modifications redesigned to work with ARDUINO UNO R3

  "Sketch uses 30042 bytes (93%) of program storage space. Maximum is 32256 bytes.
  Global variables use 1137 bytes (55%) of dynamic memory, leaving 911 bytes for local variables. Maximum is 2048 bytes."


  PID for this is included in the progmem
                                                          BOTTOM    *UP
  const float DF_PID_P[]  __attribute__((__progmem__)) = { 5.10,   5.77};
  const float DF_PID_I[]  __attribute__((__progmem__)) = { 0.16,   0.37};
  const float DF_PID_D[]  __attribute__((__progmem__)) = {40.71,  22.61};

  parts used:
  1 - arduino uno r3 development board
  2pcs max 6675
  2 pcs bta 16 triac
  1 pc 4n25 opto isolator
  2 pcs 3021 opto isolator
  1 lcd i2c 16x2
  1 rotary encoder with button
  1 pc 3x5mm on/off toggle switch
  3 pcs 5x8mm on/off toggle switch
  1 pc 2 way switching power supply 5v 12v 3A
  1 pc 240x240mm far infrared preheating ceramic
  1 pc 80x80mm far infrared ceramic for top heater
  1 pc 240mm brushless ball bearing fan = for preventing the heat from the preheater to the chassi
  1 pc 80mm brushless ball bearing fan = to cool down the top heater
  2 pcs 60mm brushless ball bearing fan = to cool down the chassi internal parts
  1 pc desoldering pen
  1 pc vacumm pump 12vdc
  2 pcs led lamp
  1 laser diode
  2 set BGA aluminum bracket
  1 set adjustable stand
  4 pcs n type mosfet driver
  1 pc dpst relay 5v
  1 pc pc817 opto isolator
  and a lots of resistors.
  10 Kohms
  1 Kohms
  10 Ohms
  47 ohms
  33 ohms

  the chassi i used came from an old hot air station

  br: Joserecon Bonilla
  email me: josereconbonilla@gmail.com
*/
